#ifndef __UTILS_H
#define __UTILS_H

#define OUTPUT_FORMAT_DEC 0
#define OUTPUT_FORMAT_HEX 1
#define OUTPUT_FORMAT_UDC 2

#ifdef __cplusplus
extern "C" {
#endif

extern int output_format;

extern void print_mm0_pb(); 
extern void print_mm1_pb(); 
extern void print_mm2_pb(); 
extern void print_mm3_pb(); 
extern void print_mm4_pb(); 
extern void print_mm5_pb(); 
extern void print_mm6_pb(); 
extern void print_mm7_pb(); 

extern void print_mm0_pw(); 
extern void print_mm1_pw(); 
extern void print_mm2_pw(); 
extern void print_mm3_pw(); 
extern void print_mm4_pw(); 
extern void print_mm5_pw(); 
extern void print_mm6_pw(); 
extern void print_mm7_pw(); 

extern void print_mm0_pd(); 
extern void print_mm1_pd(); 
extern void print_mm2_pd(); 
extern void print_mm3_pd(); 
extern void print_mm4_pd(); 
extern void print_mm5_pd(); 
extern void print_mm6_pd(); 
extern void print_mm7_pd(); 

extern void print_mm0_pq(); 
extern void print_mm1_pq(); 
extern void print_mm2_pq(); 
extern void print_mm3_pq(); 
extern void print_mm4_pq(); 
extern void print_mm5_pq(); 
extern void print_mm6_pq(); 
extern void print_mm7_pq(); 

extern void print_xmm0(); 
extern void print_xmm1(); 
extern void print_xmm2(); 
extern void print_xmm3(); 
extern void print_xmm4(); 
extern void print_xmm5(); 
extern void print_xmm6(); 
extern void print_xmm7(); 

extern void print_xmm_regs();
extern void print_mm_regs_pb();
extern void print_mm_regs_pw();
extern void print_mm_regs_pd();
extern void print_mm_regs_pq();

extern void init_mmx_mode();
extern void enter_mmx_mode();
extern void leave_mmx_mode();
extern int  cpuinfo();
extern void print_cpuinfo();

extern int cpuid_fpu_present;
extern int cpuid_fsfr_present;
extern int cpuid_mmx_present;
extern int cpuid_mmxex_present;
extern int cpuid_sse_present;
extern int cpuid_sse2_present;
extern int cpuid_sse3_present;
extern int cpuid_3dnow_present;
extern int cpuid_3dnowex_present;

#ifdef __cplusplus
}
#endif


#endif
